[BZOJ2177][最小/最大(曼哈顿距离)生成树]曼哈顿最小生成树

codeforces 100959B Airports 曼哈顿距离最大生成树 写了两种做法。 1. 对于每个点,向八个象限建最长边,注意最长边没有最短边的对称性,故每个点不能只枚举4个方向,要8个方向都枚举。这个做法速度较快,用的树状数组: #include using namespace std; typedef pair pii; const int maxn=100005; const int inf=2e9+1; int n,pos[maxn],f[maxn] 阅读详情
题意

给定平面内一些点,求最小曼哈顿距离生成树


看这篇咯http://blog.youkuaiyun.com/acm_cxlove/article/details/8890003

#include <cstdio>
#include <string>
#include <cstring>
#include <iostream>
#include <algorithm>
#define N 100010
#define X first
#define Y second

using namespace std;

typedef long long ll;

int n,m,cnt,cnt0;
int B[N],C[N],D[N],fa[N];
ll Ans;
struct Point{
    int x,y,id;
}A[N];
struct edge{
    int u,v,w;
    edge(int u=0,int v=0):u(u),v(v){}
    friend bool operator <(edge a,edge b){
        return a.w<b.w;
    }
}E[N<<3];

inline bool cmpx(Point a,Point b){
    return a.x<b.x;
}

inline bool cmpy(Point a,Point b){
    return a.y<b.y;
}

inline bool back(Point a,Point b){
    return a.id<b.id;
}

inline void reaD(int &x){
    char c=getchar(); x=0; int f=1;
    for(;c>'9'||c<'0';c=getchar())if(c=='-') f=-1;
    for(;c>='0'&&c<='9';x=x*10+c-'0',c=getchar()); x*=f;
}

inline int query(int x){
    int Min=1<<30,r=-1;
    for(;x<=cnt;x+=x&-x)
        if(C[x]<Min) Min=C[x],r=D[x];
    return r;
}

inline void Add(int x,int y,int z){
    for(;x;x-=x&-x)
        if(y<C[x]) C[x]=y,D[x]=z;
}

int find(int x){
    return fa[x]==x?x:fa[x]=find(fa[x]);
}

int main(){
    reaD(n);
    for(int i=1;i<=n;i++)
        reaD(A[i].x),reaD(A[i].y),A[i].id=i;
    for(int i=1;i<=n;i++) B[i]=A[i].y-A[i].x;
    //1
    sort(A+1,A+1+n,cmpx);
    sort(B+1,B+1+n); cnt=unique(B+1,B+1+n)-B-1;
    memset(C,0x7f,sizeof(C)); memset(D,-1,sizeof(D));
    for(int i=n;i;i--){
        int x=lower_bound(B+1,B+1+cnt,A[i].y-A[i].x)-B,pos=query(x);
        if(pos>0) E[++cnt0]=edge(A[i].id,pos);
        Add(x,A[i].x+A[i].y,A[i].id);
    }
    //4
    memset(C,0x7f,sizeof(C)); memset(D,-1,sizeof(D));
    for(int i=1;i<=n;i++) B[i]=-A[i].x-A[i].y;
    sort(B+1,B+1+n); cnt=unique(B+1,B+1+n)-B-1;
    for(int i=n;i;i--){
        int x=lower_bound(B+1,B+1+cnt,-A[i].x-A[i].y)-B,pos=query(x);
        if(pos>0) E[++cnt0]=edge(A[i].id,pos);
        Add(x,A[i].x-A[i].y,A[i].id);
    }
    //2
    sort(A+1,A+1+n,cmpy);
    memset(C,0x7f,sizeof(C)); memset(D,-1,sizeof(D));
    for(int i=1;i<=n;i++) B[i]=A[i].x-A[i].y;
    sort(B+1,B+1+n); cnt=unique(B+1,B+1+n)-B-1;
    for(int i=n;i;i--){
        int x=lower_bound(B+1,B+1+cnt,A[i].x-A[i].y)-B,pos=query(x);
        if(pos>0) E[++cnt0]=edge(A[i].id,pos);
        Add(x,A[i].x+A[i].y,A[i].id);
    }
    //3
    memset(C,0x7f,sizeof(C)); memset(D,-1,sizeof(D));
    for(int i=1;i<=n;i++) B[i]=A[i].y+A[i].x;
    sort(B+1,B+1+n); cnt=unique(B+1,B+1+n)-B-1;
    for(int i=1;i<=n;i++){
        //printf("%d\n",i);
        int x=lower_bound(B+1,B+1+cnt,A[i].y+A[i].x)-B,pos=query(x);
        if(pos>0) E[++cnt0]=edge(A[i].id,pos);
        Add(x,A[i].x-A[i].y,A[i].id);
    }
    //mst
    sort(A+1,A+1+n,back);
    for(int i=1;i<=cnt0;i++)
        E[i].w=abs(A[E[i].u].x-A[E[i].v].x)+abs(A[E[i].u].y-A[E[i].v].y);
    sort(E+1,E+1+cnt0);
    //for(int i=1;i<=cnt0;i++) printf("%d %d %d\n",E[i].u,E[i].v,E[i].w);
    for(int i=1;i<=n;i++) fa[i]=i;
    for(int i=1;i<=cnt0;i++){
        if(find(E[i].u)==find(E[i].v)) continue;
        fa[find(E[i].u)]=find(E[i].v);
        Ans+=E[i].w;
    }
    cout<<Ans<<endl;
    return 0;
}

另外还有求最大曼哈顿距离生成树,好像有个叫Boruvka的算法
就是每次找到图中独立的一个团,找到一条最长的一个端点在这个团中另一个端点属于另一个团的边,把这两个端点属于的团合并,记录答案。

#include <cstdio>
#include <cstring>
#include <string>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#define N 100010
#define X first
#define Y second

using namespace std;

typedef long long ll;
typedef pair<int,int> paris;
typedef pair<ll,paris> parpar;
typedef set<paris>::iterator itr;

int n;
int fa[N],vis[N];
int val[N][4];
paris p[N];
ll Ans;
set<paris> S[4];
vector<parpar> A;
vector<int> V[N];

int dx[4]={1,1,-1,-1},dy[4]={1,-1,-1,1};

inline void reaD(int &x){
    char c=getchar();x=0; int f=1;
    for(;c>'9'||c<'0';c=getchar())if(c=='-')f=-1;
    for(;c>='0'&&c<='9';x=x*10+c-'0',c=getchar()); x*=f;
}

int find(int x){ return fa[x]==x?x:fa[x]=find(fa[x]); }

inline bool iUnion(int x,int y){
    x=find(x); y=find(y);
    if(x==y) return 0;
    if(V[x].size()>V[y].size()) swap(x,y);
    for(int i=0;i<V[x].size();i++)
        V[y].push_back(V[x][i]);
    V[x].clear();
    fa[x]=y;
    return 123;
}

int main(){
    freopen("mst.in","r",stdin);
    freopen("mst.out","w",stdout);
    reaD(n);
    for(int i=1;i<=n;i++)
        reaD(p[i].X),reaD(p[i].Y);
    for(int i=1;i<=n;i++){
        fa[i]=i,V[i].push_back(i);
        for(int j=0;j<4;j++){
            val[i][j]=p[i].X*dx[j]+p[i].Y*dy[j];
            S[j].insert(paris(val[i][j],i));
        }
    }
    int linked=0;
    while(!linked){
        memset(vis,0,sizeof(vis));
        for(int i=1;i<=n;i++){
            int x=find(i);
            if(vis[x]) continue;
            if(V[x].size()==n){ linked=1; break; }
            vis[x]=1;
            for(int j=0;j<V[x].size();j++){
                int u=V[x][j];
                for(int k=0;k<4;k++)
                    S[k].erase(paris(val[u][k],u));
            }
            int v; ll Max=-1;
            for(int j=0;j<V[x].size();j++){
                int u=V[x][j];
                for(int k=0;k<4;k++){
                    itr it=S[(k+2)%4].end(); it--;
                    if(1ll*it->X+val[u][k]>Max) Max=1ll*it->X+val[u][k],v=it->Y;
                }
            }
            A.push_back(parpar(Max,paris(x,v)));
            for(int j=0;j<V[x].size();j++){
                int u=V[x][j];
                for(int k=0;k<4;k++)
                    S[k].insert(paris(val[u][k],u));
            }
        }
        for(int i=0;i<A.size();i++){
            int u=A[i].Y.X,v=A[i].Y.Y; ll w=A[i].X;
            if(iUnion(u,v)) Ans+=w;
        }
    }
    cout<<Ans<<endl;
    return 0;
}
曼哈顿距离最小生成树与莫队算法 一、曼哈顿距离最小生成树 曼哈顿距离最小生成树问题可以简述如下: 给定二维平面上的N个点,在两点之间连边的代价为其曼哈顿距离,求使所有点连通的最小代价。 朴素的算法可以用O(N2)的Prim,或者处理出所有边做Kruskal,但在这里总边数有O(N2)条,所以Kruskal的复杂度变成了O(N2logN)。 但是事实上,真正有用的边远没有O(N2)条。我们考虑每个点会和其他一些什么样的点连 阅读详情

相关推荐

16G显存+llama.cpp跑大模型的黄金配置指南

大语言模型(LLM)本地部署的核心瓶颈在于显存与推理效率的平衡。llama.cpp作为轻量级C/C++推理引擎,通过GGUF模型格式、量化压缩(如Q4_K_M)和CUDA底层优化,显著降低GPU资源需求。在消费级硬件中,16G显存成为兼顾模型能力(如Qwen3-4B、Llama-3-8B)、长上下文支持(4K token)与系统稳定性的关键阈值。它既规避了12G显存的容量焦虑,又绕开了24G高端卡的成本与散热负担,特别适合Windows 11原生环境下的生产级AI应用,如RAG、智能客服与文档分析。

weixin_32629853的博客 404

图论 —— 生成树 —— 曼哈顿距离最小生成树

【概述】 当给出一些二维平面的点时,记两点间距离为曼哈顿距离,此时的最小生成树,称为曼哈顿最小距离生成树。 对于 n 个点来说,最朴素的做法是暴力求出所有所有点两两之间的曼哈顿距离,然后再跑最小生成树算法,以得到曼哈顿最小距离生成树,但这样来做,由于总边数有 n^2 条,时间复杂度会达到 O(n^3) 或 O(n^2 logn) 对于 Kruskal 来说,针对这种曼哈顿距离的 MST 问题...

Alex_McAvoy的博客 4207

docker拉取镜像报错:Error response from daemon: Get “https://registry-1.docker.io/v2/“: dial tcp

docker拉取镜像报错:Error response from daemon: Get “https://registry-1.docker.io/v2/“: dial tcp

m0_55333789的博客 1556

Gym 100959B Airports(曼哈顿距离最大生成树)

曼哈顿距离最小生成树:https://www.cnblogs.com/xzxl/p/7237246.html 这道题显然是求曼哈顿距离的最大生成树,和求最小生成树一样,用个树状数组维护最值,加边后跑kruskal,不同的是最大生成树需要枚举8个方向的最大值。 #include <iostream> #include <cstdio> #include <cs...

Max的博客 969

从零开始搭建一个高性能电流镜:手把手教你设计Wide-Swing Cascode结构

本文详细解析了Wide-Swing Cascode电流镜的设计原理与实战流程。针对低压高性能模拟电路设计的核心挑战,文章手把手指导如何从理论分析、参数计算到仿真验证,搭建一个兼具高输出阻抗和低输出电压裕度的电流镜结构,并深入探讨了偏置电路生成、性能优化及版图匹配等关键要点。

weixin_29294975的博客 622

高通 Gen AI 推理扩展 (GENIE)(5):实战指南与Engine API深度解析

本文深入解析高通Gen AI推理扩展(GENIE)的Engine API核心功能与实战应用,涵盖引擎实例化、多引擎动态切换、性能调优及跨平台部署等关键技巧。通过详细代码示例和性能数据,帮助开发者高效利用GENIE进行AI推理,提升应用性能与稳定性。

weixin_29065959的博客 463

[Boruvka算法 曼哈顿距离最大生成树] 省选模拟赛 4 C. 树树树 mst

题目大意 求曼哈顿距离最大生成树 n≤100000n\leq 100000Boruvka算法是什么呢 也就是说 我们只要每次求一个连通块连出去的最远的边 把这些边都加入 只要这样 O(logn)O(\log n)就能得到一棵最大生成树每次求两个连通块之间最大边的时候,就是求 |xi−xj|+|yi−yj||x_i − x_j| + |y_i − y_j| 的最大值,分情况用set维护即可。但是神

雯舞 3293

abaqus 根据坐标施加载荷- Analytical Field 载荷映射

在一些类型的分析中,需要将按位置分布的载荷施加到结构上,比如流体分析导出了结构的气动载荷、或者温度载荷,需要将压强分布、温度分布载荷施加到固体上。这种分析可以使用abaqus中的Analytical Field实现。 1 例子 1.1 结构 一个100*100mm的面,面的载荷分布函数为p=(x2+y2)0.5/((20.5)*100) MPa,即(0, 0)的压强为0,(100, 100)的压强为1。 1.2 载荷 载荷函数:p=(x^2+y^2)^0.5/((2^0.5)*100) in exce.

shengyutou的博客 2万+

【NOI模拟赛】最大生成树(Boruvka算法,并查集)

好起来了!好起来了!猜对了!

DD(XYX)的硫氰化氘博客 603

银行一表通监管报送系统详解

国家金融监管总局对于“一表通”的总体描述为:通过建立一套明细级、标准化的数据体系和汇总计算规则,将银行机构传送至监管可信区的业务明细数据汇总生成财务指标、监管指标和监管报表,大幅提升监管数据时效性,统一数据标准,实现数据间的穿透和整合,同时改变机构多头报送数据模式,减轻机构报送负担。

银行信息系统应用架构详解 2513

学Simulink——基于Simulink的单相PWM整流器PI电压外环+电流内环控制建模示例

本文详细介绍了基于Simulink的单相PWM整流器双闭环控制仿真方法。通过电压外环PI控制器调节有功功率生成电流指令,电流内环PI控制器实现正弦电流跟踪,最终达到输出电压稳定(400V±2V)、输入电流THD<3%、功率因数>0.99的目标。文章包含系统架构、数学模型、Simulink搭建步骤(主电路、PI控制器、SPWM调制等)及三种典型工况的仿真验证,并给出电感设计、数字实现等工程实践要点。该方案克服了传统整流器高谐波、低功率因数的问题,为绿色电源开发提供了可验证的仿真模型。

xiaoheshang_123的博客 74

BZOJ 2177: 曼哈顿最小生成树

Sol 考了好几次曼哈顿最小生成树,然而一直不会打...这次终于打出来了...神tm调试了2h...好蛋疼... 首先曼哈顿最小生成树有个结论就是讲它每45度分出一个象限,对于每个点,只与每个象限中离他最近的点连线,做最小生成树,就是他们的曼哈顿最小生成树. 关于证明,先让我想想再来补. 我们的问题两个方面:为什么将平面分成8块;为什么只需要连接每块中距离最小的点. 不过好像没...

aisen1985的博客 235

零基础学写《扫雷》游戏(Qt扫雷源码)

扫雷游戏是在windows系统中自带的游戏,他的游戏玩法其实很简单,20世纪初期电脑上没有啥游戏可以玩,所以扫雷游戏也算是当时是最常火爆的一个电脑游戏。以下文章详细介绍扫雷游戏的实现。实现语言为C++。

啊渊的专栏 1万+

BZOJ 2177: 曼哈顿最小生成树 曼哈顿最小生成树

2177: 曼哈顿最小生成树 Time Limit: 10 Sec  Memory Limit: 259 MB Submit: 281  Solved: 117 [Submit][Status][Discuss] Description 平面坐标系xOy内,给定n个顶点V = (x , y)。对于顶点u、v,u与v之间的距离d定义为|xu – xv| + |yu – yv|  你的

BlackJack 1239

efm32 入门.pdf

本PDF共计22页,介绍的是操作驱动API,下载与否自己斟酌。

Camera2Demo

在Camera2 的基础上进行封装,使得Camera2一堆初始化逻辑与Activity分离,降低耦合度,完成预览拍照并保存的操作

BZOJ 2177 最小曼哈顿生成树

留板。 #include using namespace std; typedef pair pii; const int maxn=100005; const long long inf=0x3f3f3f3f3f3f3f3f; int n,pos[maxn],f[maxn]; long long bit[maxn],res,x,y; struct edge { int u,v;

亂丟程式碼的天空 450

pscad IEEE标准系统搭建说明

pscad IEEE标准系统搭建说明,包含典型的IEEE 9节点、14节点、30节点、39节点和118节点系统。内含标准测试系统的原始数据和潮流结果。

BZOJ 2177 [曼哈顿最小生成树]

DescriptionDescription 平面坐标系xOyxOy内,给定nn个顶点V=(x,y)V = (x , y)。对于顶点u,v,uu,v,u与vv之间的距离dd定义为|xu–xv|+|yu–yv||x_u – x_v| + |y_u – y_v| 。你的任务就是求出这nn个顶点的最小生成树。 把平面划分为八个区域以后只有这八个区域的最近点与该点的连边在KruscalKrusc

Vectorxj的博客 924

蓝牙模块HM-10手册

蓝牙模块HM-10手册,该手册对蓝牙模块HM-10进行了详细的介绍和使用方法以及一些AT指令。

bzoj2177/51nod-1213 曼哈顿距离最小生成树

算法分析对不起我写这个的时候我们国庆节只放了一天假,所以我精神有点不正常…大家忽略一些不太对的东西即可。原理分析曼哈顿距离:对于两点p1(x1,y1),p2(x2,y2),它们之间的曼哈顿距离为|x1-x2|+|y1-y2| 那么如何迅速地求曼哈顿距离最小生成树呢?我们找到一个点p1,然后以它为原点建立坐标轴,那么它只需要与这八个区域里的每个区域和它曼哈顿距离最近的点连一条边即可。 这是为什

litble的成(tui)长(fei)史 760

【BZOJ-2177】曼哈顿最小生成树 Kruskal + 树状数组

2177: 曼哈顿最小生成树 Time Limit:10 SecMemory Limit:259 MBSubmit:190Solved:77[Submit][Status][Discuss] Description 平面坐标系xOy内,给定n个顶点V = (x , y)。对于顶点u、v,u与v之间的距离d定义为|xu – xv| + |yu – yv|你的任务就是求...

weixin_30322405的博客 124

BZOJ.2177.曼哈顿最小生成树(Kruskal)

\(Solution\) 参考 对于每个点,向唯一有可能与它形成MST的8个点连边,由于是双向单边,所以每个点最多连出4条边(证明见blog) 怎么找到一个区域内最近的点? 只考虑y轴右侧45°的区域,其余部分可以通过坐标变换移动到这一区域 设当前点P(x0,y0),这一区域一点P1(x1,y1),满足x1>x0 && y1-x1>y0-x0 那么dis(AB)= y1...

weixin_30345055的博客 124

HDU - 6187 最大生成树

要想每一个地方都到达,那么肯定没环,所以就是去掉环中最小的一条边,反过来就是保留所有大的边,也就是最大生成树。 #include&lt;iostream&gt; #include&lt;algorithm&gt; using namespace std; const int maxn=2e5+10; struct node{ int u,v,w; }g[maxn]; int f...

兜率工的博客 308

知识点 - 曼哈顿距离最小生成树

知识点 - 曼哈顿距离最小生成树 解决问题类型: 求解曼哈顿距离上的最小生成树 前置知识 曼哈顿距离:给定二维平面上的N个点,在两点之间连边的代价。(即distance(P1,P2)=∣x1-x2∣+∣y1-y2∣distance(P1,P2) = |x1-x2|+|y1-y2|distance(P1,P2)=∣x1-x2∣+∣y1-y2∣) 曼哈顿距离最小生成树问题求什么?求使所有点连通...

qq_41848675的博客 992

曼哈顿距离最小生成树

一、前人种树 博客:曼哈顿距离最小生成树与莫队算法 博客:学习总结:最小曼哈顿距离生成树 二、知识梳理 曼哈顿距离:给定二维平面上的N个点,在两点之间连边的代价。(即distance(P1,P2) = |x1-x2|+|y1-y2|) 曼哈顿距离最小生成树问题求什么?求使所有点连通的最小代价。 最小生成树的“环切”性质:在图G = (V, E)中,如果存在一个环,那么把环上的最大...

weixin_34019144的博客 337

曼哈顿距离最小生成树(树状数组)

转自:https://www.cnblogs.com/Anding-16/p/7367845.html POJ-3241 Object Clustering Dscription We have N (N ≤ 10000) objects, and wish to classify them into several groups by judgement of their resembla...

刘二狗的博客 1324

关于曼哈顿距离下的最小生成树

这些天一直在集训,考了十几次…… zzy出了一道曼哈顿距离下的最小生成树,考场上我没做出来…… 嗯……这种题目的问题在于,你没办法把每两个点都建一条边…… 但是因为是曼哈顿距离,所以有一些特殊性质 容易证明,将某个点为原点建立笛卡尔坐标系,将坐标系分为每45°角为一块的八个区域 那么这个点向每个区域只会朝其中的某个点连边…… 为什么说容易证明,因为我不会证……网上MS有这种证明的说……

OrpineX的专栏 5100

hdu 4666 线段树+最大曼哈顿距离

由于要求n个点的最大曼哈顿距离,并且要执行插入,删去操作,如果对距离公式什么都不做的话,会发现复杂度太高了,tle肯定。再来看一下二维式子,无非有四种方式: (x1-x2)+(y1-y2),(-x1+x2)+(y1-y2),(x1-x2)+(y2-y1),(x2-x1)+(y2-y1). 毫无规律再变化一下。 (x1+y1)-(x2+y2),(-x1+y1)-(-x2+y2),(x1-y1)

driver13的博客 1234

hdu 5626 Clarke and points 最大曼哈顿距离

题目:点击打开链接 题意:给n( 分析:这题和poj2926那题一样。 |xi−xj|+|yi−yj|,拆绝对值可以得到: 正正:xi−xj+yi−yj=(xi+yi)−(xj+yj) 负负:−xi+xj−yi+yj=(−xi−yi)−(−xj−yj) 正负:xi−xj−yi+yj=(xi−yi)−(xj−yj) 负正:−xi+xj+yi−yj=(−xi+yi)−

01的世界 917
上一篇: [BZOJ3270][高斯消元][概率与期望]博物馆
下一篇: [BZOJ3143][Hnoi2013][概率与期望][高斯消元]游走
LowestJN
博客等级 码龄10年 76粉丝 422原创
评论
成就一亿技术人!
拼手气红包6.0元
还能输入1000个字符
 
 条评论被折叠 查看
添加红包

请填写红包祝福语或标题

个

红包个数最小为10个

元

红包金额最低5元

当前余额3.43元 前往充值 >
需支付:10.00元
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付元
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值